const { SerialPort } = require('serialport');

// シリアルポートの設定
const SERIAL_PORT_OPTION = {
    path: '/dev/ttymxc1',
    baudRate: 38400,
    dataBits: 8,
    parity: 'none',
    stopBits: 1,
    flowControl: false,
};

let port;

function openSerialPort() {
    port = new SerialPort(SERIAL_PORT_OPTION, (err) => {
        if (err) {
            console.error('Serial port open error:', err.message);;
        }
    });

    port.on('data', (data) => {
        console.log('Received:', data.toString());
    });

    port.on('close', () => {
        console.log('Serial port closed event.');
    });
}

function ___(s) {
    console.log(s);
}

function sendData() {
    ___('sendData');
    if (port && port.isOpen) {
        port.write('Your data here\r\n');
    }
}

openSerialPort();

// 定期的にデータを送信するタイマーを設定
const sendDataInterval = setInterval(sendData, 2000);

function closeSerialPort() {
    console.log('Serial port closing.');
    port.close((err) => {
        if (err) {
            console.error('Error closing port:', err.message);
        } else {
            console.log('Serial port closed successfully.');
            clearInterval(intervalID);
            process.exit();
        }
    });
}

// process.on('SIGINT', closeSerialPort);
// process.on('SIGTERM', closeSerialPort);
var intervalID;
// 1分後にデータ送信を停止し、シリアルポートを閉じる
setTimeout(() => {
    clearInterval(sendDataInterval);
    intervalID = setInterval(closeSerialPort, 3000);
}, 30000);
